<?php

$uNameErr = $passErr = $confPassErr = $fNameErr = $lNameErr = $addrErr = $addrTwoErr = $cityErr = $stateErr = $zipErr =
$phoneErr = $emailErr = $genderErr = $maritalErr = $dateErr = "";

$uName = $passWord = $confPassWord = $fName = $lName = $address = $addressTwo = $city = $state = $zip = $phoneNum =
$email = $gender = $marital = $date = "";

$isValid = false;

if ($_SERVER["REQUEST_METHOD"] == "POST"){
    $isValid = true;

   if(!isset($_POST['userName'])){
       $isValid = false;
   }elseif(empty($_POST['userName'])){
       $uNameErr = "Please enter a User Name.";
       $isValid = false;
   }else{
       $uName = clean_input($_POST['userName']);
       if(strlen($uName) < 6 || strlen($uName) > 50){
           $uNameErr = "User Name must be 6 to 50 characters long.";
           $isValid = false;
       }
   }

   if(!isset($_POST['password'])){
       $isValid = false;
   }elseif(empty($_POST['password'])){
       $passErr = "Password is required!";
       $isValid = false;
   }else{

        //make me test the length separately
       $passWord = clean_input($_POST['password']);
       if(!preg_match("/^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\s).{8,50}$/", $passWord)){
           $passErr = "Password must be between 8 and 50 characters long, and contain at least one of each:
                        Capital letter, Lowercase letter, Digit, and Special character";
           $isValid = false;
       }
   }

   if(!isset($_POST['confirmPassword'])){
       $isValid = false;
   }elseif(empty($_POST['confirmPassword'])) {
       $pass1Err = "Please enter a password that matches the first!";
       $isValid = false;
   }else{
       $confPassWord = clean_input($_POST['confirmPassword']);
       if ($passWord !== $confPassWord) {
           $confPassErr = "Please enter a password that matches the first!";
           $isValid = false;
       }
   }

   if(!isset($_POST['firstName'])){
       $isValid = false;
   }elseif(empty($_POST['firstName'])){
       $fNameErr = "First name required";
       $isValid = false;
   }else{
       $fName = clean_input($_POST['firstName']);
       if(strlen($fName) > 50){
           $fNameErr = "Maximum of 50 characters";
           $isValid = false;
       }
   }

   if(!isset($_POST['lastName'])){
       $isValid = false;
   }elseif(empty($_POST['lastName'])){
       $lNameErr = "Last name required";
       $isValid = false;
   } else {
       $lName = clean_input($_POST['lastName']);
       if(strlen($lName) > 50){
           $lNameErr = "Maximum of 50 characters";
           $isValid = false;
       }
   }

   if(!isset($_POST['addressLine1'])){
       $isValid = false;
   }elseif(empty($_POST['addressLine1'])){
       $addrErr = "Address is required";
       $isValid = false;
   } else {
       $address = clean_input($_POST['addressLine1']);
       if(strlen($address) > 100){
           $addrErr = "Maximum of 100 characters - Use address Line 2 if needed";
           $isValid = false;
       }
   }

   if(isset($_POST['addressLine2'])){
       $addressTwo = clean_input($_POST['addressLine2']);
   }else{
       if(strlen($addressTwo) > 100){
           $addrTwoErr = "Maximum of 100 characters";
           $isValid = false;
       }
   }

   if(!isset($_POST['city'])){
       $isValid = false;
   }elseif(empty($_POST['city'])){
       $cityErr = "City required";
       $isValid = false;
   } else {
       $city = clean_input($_POST['city']);
       if(strlen($city) > 50){
           $cityErr = "Maximum of 50 characters";
           $isValid = false;
       }
   }

//state state stateErr
   if(isset($_POST['state'])){
       $state = clean_input($_POST['state']);
       if($state == "#"){
           $stateErr = "Selection required";
           $isValid = false;
       }
   }else {
       $stateErr = "Selection required";
       $isValid = false;
   }

   if(!isset($_POST['zip'])){
       $isValid = false;
   }elseif(empty($_POST['zip'])){
       $zipErr = "Zip code required";
       $isValid = false;
   } else {
       $zip = clean_input($_POST['zip']);
       if(!preg_match("/^[0-9]{5}(?:-[0-9]{4})?$/", $zip)){
           $zipErr = "Please enter a valid zipcode";
           $isValid = false;
       }
   }

//phoneNumber phoneNum phoneErr
   if(!isset($_POST['phoneNumber'])){
       $isValid = false;
   }elseif(empty($_POST['phoneNumber'])){
       $phoneErr = "Phone number required!";
       $isValid = false;
   } else {
       $phoneNum = clean_input($_POST['phoneNumber']);
       if(!preg_match("/^(1-)?\d{3}-\d{3}-\d{4}$/", $phoneNum)){
           $phoneErr = "Please enter a valid phone number";
           $isValid = false;
       }
   }

//email email emailErr
   if(!isset($_POST['email'])){
       $isValid = false;
   }elseif(empty($_POST['email'])){
       $emailErr = "Email is required!";
       $isValid = false;
   }else{
       $email = clean_input($_POST['email']);
       if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
           $emailErr = "Please enter a valid email address";
           $isValid = false;
       }
   }

   if(isset($_POST["gender"])) {
       $gender = clean_input($_POST["gender"]);
       if (empty($_POST["gender"])) {
           $genderErr = "Gender is required";
           $isValid = false;
       }
   } else {
       $genderErr = "Gender is required";
       $isValid = false;
   }

   if(isset($_POST["maritalStatus"])) {
       $marital = clean_input($_POST["maritalStatus"]);
       if (empty($_POST["maritalStatus"])) {
           $maritalErr = "Martial Status is required";
           $isValid = false;
       }
   } else {
       $maritalErr = "Martial Status is required";
       $isValid = false;
   }

   if(isset($_POST['dateOfBirth'])){
       $date = clean_input($_POST['dateOfBirth']);
       if(empty($date)){
           $dateErr = "Date of birth is required";
           $isValid = false;
       }
   }else{
       $dateErr = "Please select a date.";
       $isValid = false;
   }
}


function clean_input($data) {
   $data = trim($data);
   $data = stripslashes($data);
   $data = htmlspecialchars($data);
   return $data;
}

?>